// example1.c
// E3D 3D library test program 1
//
// link to lib3d.a & libzb.a !
//
// This example shows how quick and easy it is to load an display
// a pre-defined 3D scene
//
// Files required:	test.scn				(3D scene file)
//							e3d1.bmp				(texture bitmap)
//							.3do models specified in test.scn

#include <stdio.h>
#include <allegro.h>
#include "zbpoly3d.h"						// needed for z-buffering
#include "lib3d.h"							// header file for 3D lib


// no comment.
int main(void) {
	int i;

	// NB: we must initialise allegro and set up a video mode
	// before calling any E3D lib functions, as the library
	// relies on this.
	allegro_init();
	check_cpu();					// so we can use MMX maybe
	install_keyboard();
	set_color_depth(16);			// first version 16-bit colour
	set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);

	// clear the screen to a colour so that we can see
	// where the 3D render window is
	clear_to_color(screen, makecol(64, 255, 64));

	// initialise the 3D engine to use a 600x400 buffer
	E3D_Init(600, 400, 20, 20, 20);

	// load in our scene
	// (this will load all models and textures required)
	i = E3D_LoadScene("example1.scn");
	if(i) exit(0);		// catch scene error

	// attach insts 6, 7, 8, 9 to inst 5
   E3D_scene.pinst[6]->attach = E3D_scene.pinst[5];
   E3D_scene.pinst[7]->attach = E3D_scene.pinst[5];
   E3D_scene.pinst[8]->attach = E3D_scene.pinst[5];
   E3D_scene.pinst[9]->attach = E3D_scene.pinst[5];

	// draw the scene until a key is pressed
	clear_keybuf();
	while(!keypressed()) {
		E3D_DrawScene(20, 40, 1);
		// rotate most instances
		for(i=0; i<6; i++) {
			E3D_scene.pinst[i]->rotn.y += 2.0;
		}
		// rotate wheels
		for(i=6; i<10; i++) {
			E3D_scene.pinst[i]->rotn.z += 6.0;
		}
	}

	// exit
	exit(0);
	return 0;								// to satisfy DJGPP
}


