// example2.c
// E3D 3D library test program 2
//
// link to lib3d.a & libzb.a !
//
// This example shows fog etc
// Textured polys are not fogged yet, however. Bummer!
//
// Files required:	example2.scn		(3D scene file)
//							ground.bmp				(texture bitmap)
//							.3do models specified in example2.scn

#include <stdio.h>
#include <allegro.h>
#include "zbpoly3d.h"						// needed for z-buffering
#include "lib3d.h"							// header file for 3D lib


// no comment.
int main(void) {

	int i;
	ThreeDeeInstance *thisinst;		// ptr for inst handling

	// NB: we must initialise allegro and set up a video mode
	// before calling any E3D lib functions, as the library
	// relies on this.
	allegro_init();
	check_cpu();					// so we can use MMX maybe
	install_keyboard();
	set_color_depth(16);			// first version 16-bit colour
	set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);

	// clear the screen to a colour so that we can see
	// where the 3D render window is
	clear_to_color(screen, makecol(64, 255, 64));

	// initialise the 3D engine to use a 400x300 buffer
	E3D_Init(400, 300, 20, 20, 20);

	// load in a simple scene with our models and texture
	E3D_LoadScene("example2.scn");

   // lets create a 6x8 grid for the ground instances
   for(i=0; i < 36; i++) {
   	thisinst = E3D_CreateInst(E3D_scene.pmodel[1]);
      if(thisinst != NULL) {
      	thisinst->posn.x = (i % 6) * 16 - 40;
         thisinst->posn.z = (i/6) * 16;
		}
	}

   // Now we create some more instances using the 3D tree
   // model, placed randomly
   for(i=0; i < 50; i++) {
		// add an instance, getting pointer to it
		thisinst = E3D_CreateInst(E3D_scene.pmodel[0]);
		if(thisinst != NULL) {
			thisinst->posn.x = (float) (rand()%500 - 250);
			thisinst->posn.z = (float) (i * 10);

      	//E3D_XlateInst(thisinst, i * 10, 0.0, i * 10); // doesn't work????
		}
	}

	// draw the scene until a key is pressed
	clear_keybuf();
	while(!keypressed()) {
		E3D_DrawScene(0, 0, 1);
		// move camera
		E3D_scene.camera.posn.z += 2.0;
	}

	// exit
	exit(0);
	return 0;								// to satisfy DJGPP
}


